var Cache = require('../cache-simple').init;

var testcases = [];
var maxOp = 100 * 100 * 10;

for (var i = 0; i < maxOp; i++) {
    testcases.push({
        key: "key_" + i,
        value: "value_" + i
    })
}

var Run = function (cache, task, num) {

    for (var i = 0; i < num; i++) {
        task(cache);
    }

    console.log("------------------");
}

var batchSet = function (cache) {

    testcases.forEach(function (ca) {
        cache.set(ca.key, ca.value);
    });

    var startTime = +new Date(), total, endTime;

    testcases.forEach(function (ca) {
        cache.set(ca.key, ca.value);
    });

    endTime = +new Date();
    total = (endTime - startTime) / 1000;

    console.log("| *set* | total cost: " + total + "s", (maxOp / total).toFixed(0) + " o/s");
}

var batchSetNew = function (cache) {

    var startTime = +new Date(), total, endTime;

    testcases.forEach(function (ca) {
        cache.set(ca.key, ca.value);
    });

    endTime = +new Date();
    total = (endTime - startTime) / 1000;

    console.log("| *setNew* | total cost: " + total + "s", (maxOp / total).toFixed(0) + " o/s");
}

var batchRemove = function (cache) {

    testcases.forEach(function (ca) {
        cache.set(ca.key, ca.value);
    });

    var startTime = +new Date(), total, endTime;

    testcases.forEach(function (ca) {
        cache.remove(ca.key);
    });

    endTime = +new Date();
    total = (endTime - startTime) / 1000;

    console.log("| *remove* | total cost: " + total + "s", (maxOp / total).toFixed(0) + " o/s");
}


var batchGet = function (cache) {

    testcases.forEach(function (ca) {
        cache.set(ca.key, ca.value);
    });

    var startTime = +new Date(), total, endTime;

    testcases.forEach(function (ca) {
        cache.get(ca.key);
    });

    endTime = +new Date();
    total = (endTime - startTime) / 1000;

    console.log("| *get* | total cost: " + total + "s", (maxOp / total).toFixed(0) + " o/s");   
}

Run(Cache(), batchSet, 10);
Run(Cache(), batchSetNew, 10);
Run(Cache(), batchRemove, 10);
Run(Cache(), batchGet, 10);

console.log('==== open update ===');

Run(Cache(null, 1000, true), batchSet, 10);
Run(Cache(null, 1000, true), batchSetNew, 10);
Run(Cache(null, 1000, true), batchRemove, 10);
Run(Cache(null, 1000, true), batchGet, 10);